var compy_bg = LoadImage("compy.png");
var compy_blank = LoadImage("compy_blank.png");
var compy_bottom = LoadImage("compy_bottom.png");
var compy_font = LoadFont("commodore_64.rfn");
var typing_sound = LoadSound("typing.ogg");
var enter_sound = LoadSound("enter.ogg");

function TypeLine(msg, font, x, y, mute) {
	if(!mute) typing_sound.play(true);
	Delay(100)
	screen = GrabImage(0,0, SW, SH);
	for(i=0;i<=msg.length;i++) {
		screen.blit(0,0);
		typed_text = msg.substring(0,i);
		font.drawText(x, y, typed_text);
		//x+=font.getStringWidth(msg[i]);
		FlipScreen();
		Delay(30);
	}
	if(!mute) {
		typing_sound.stop();
		enter_sound.play();
		while(enter_sound.isPlaying()) {}
	} else {
		Delay(20);
	}
}

function DrawText(x,y,str,font,color) {
	old_col = font.getColorMask();
	font.setColorMask(color);
	font.drawText(x,y,str);
	font.setColorMask(old_col);
}

function ClearKeyQueue() { 
  while (AreKeysLeft()) GetKey(); 
} 

function Menu() {
	compy_bg.blit(0,0);
	TypeLine("atarigame2.exe", compy_font, 113, 58);
	options = ["Classic Mode" , "Enhanced Mode (Coming soon!)", "Play Custom maps (Coming soon!)", "Map Editor (Coming Soon!)", "Instructions", "Exit"];

	curr_option = 0;
	curr_option_col = CreateColor(0,0,255);	
	y = 340;
	while(true) {
		compy_bg.blit(0,0);
		DrawText(113,58,"atarigame2.exe", compy_font, White)
		for(i=0;i<options.length;i++) {
			if(curr_option==i) DrawText(86,y+(12*i),options[i], compy_font,curr_option_col);
			else DrawText(86,y+(12*i), options[i], compy_font, White);
		}
		compy_bottom.blit(0,0);
		FlipScreen();
		if(y==80) {
			//start_time = GetTime();
			key = GetKey();
			if(key==KEY_ESCAPE) Exit();
			if(key==KEY_DOWN && curr_option < options.length-1) curr_option++;
			else if(key==KEY_UP && curr_option > 0) curr_option--;
			else if(key==KEY_ENTER) {
				if(curr_option==0) return "classic";
				//else if(curr_option==1) return "new";
				//else if(curr_option==2) return "custom";
				else if(curr_option==3) ChooseMap();
				else if(curr_option==4) Instructions();
				else if(curr_option==5) Exit();
			}
		}
		else y-=10;
		Delay(50);
	}
}

function Instructions() {
	var player_image = LoadImage("player_image.png");
	var secret_image = LoadImage("secret_image.png");
	var faster_image = LoadImage("faster_image.png");
	var forcefield_anim = LoadAnimation("../spritesets/forcefield.mng");
	//Rectangle(0,0,SW,SH, Black);
	compy_blank.blit(0,0);
	compy_font.drawText(SW/2-(compy_font.getStringWidth("Instructions")/2),58, "Instructions");
	player_image.blit(100, 100);
	compy_font.drawTextBox(136,80, 350, 100,0, "Your name is Secret Collect. You must explore futuristic mazes to find secrets. To move use the arrow keys.");
	secret_image.blit(100,174);
	compy_font.drawTextBox(136,154, 350,100,0,"These are secrets. To move on to the next level, you must get to the secret before time runs\nout");
	FlipScreen();
	GetKey();
	start_time = GetTime();
	cycles=0;
	while(true) {
		compy_blank.blit(0,0);
		compy_font.drawText(SW/2-(compy_font.getStringWidth("Instructions")/2),58, "Instructions");
		faster_image.blit(100,87);
		compy_font.drawTextBox(136,87,350,100,0, "This will make you go faster");
		forcefield_anim.drawFrame(87,150);
		compy_font.drawTextBox(136,150,350,100,0, "This is a forcefield. Don't touch!");
		if(cycles%12==0) forcefield_anim.readNextFrame();
		FlipScreen();
		cycles++;
		if(start_time+500<=GetTime() && IsKeyPressed(KEY_ENTER)) {
			start_time = GetTime();
			ClearKeyQueue();
			break;
		}
	}
	compy_blank.blit(0,0);
	compy_font.drawText(SW/2-(compy_font.getStringWidth("Instructions")/2),58, "Instructions");
	compy_font.drawTextBox(87,87,390,100,0, "After finishing a level, the amount of time you have left will be added to your score.");
	compy_font.drawTextBox(87,150,390,100,0, "In enhanced mode, there will be new baddies and traps. You must discover for yourself what they do and what to watch\nout for.");
	FlipScreen();
	GetKey();
}